import * as tape from "tape";
import {pool} from "../../pool";

tape(__filename, async (t) => {
    await pool.acquire(async (connection) => {
        await pool.acquire(async (connection2) => {
            await connection.rawQuery(`
                DROP TABLE IF EXISTS selectMaxIdTable;
            `);
            await connection.rawQuery(`
                CREATE TABLE IF NOT EXISTS selectMaxIdTable (
                    \`someId\` BIGINT UNSIGNED NOT NULL AUTO_INCREMENT,
                    \`someValue\` BIGINT UNSIGNED NOT NULL,
                    PRIMARY KEY(\`someId\`),
                    CONSTRAINT blah UNIQUE (someValue)
                ) AUTO_INCREMENT = 1;
            `);

            /**
             * https://stackoverflow.com/a/41178461/2484110
             */
            await connection.rawQuery("SET TRANSACTION ISOLATION LEVEL REPEATABLE READ;");
            await connection2.rawQuery("SET TRANSACTION ISOLATION LEVEL REPEATABLE READ;");
            await connection2.rawQuery(`
                INSERT INTO selectMaxIdTable (someValue) VALUES (1);
            `);
            await connection.rawQuery("START TRANSACTION;");
            console.log("connection1 in transaction");
            await connection2.rawQuery("START TRANSACTION;");
            console.log("connection2 in transaction");

            console.log((await connection.rawQuery(`
                SELECT * FROM selectMaxIdTable WHERE someValue = 1;
            `)).results);
            await connection2.rawQuery(`
                UPDATE selectMaxIdTable SET someValue = 10 WHERE someValue = 1;
            `);
            console.log((await connection.rawQuery(`
                SELECT * FROM selectMaxIdTable WHERE someValue = 1;
            `)).results);

            await connection2.rawQuery("COMMIT;");
            console.log((await connection.rawQuery(`
                SELECT * FROM selectMaxIdTable WHERE someValue = 1;
            `)).results);
            console.log((await connection.rawQuery(`
                DELETE FROM selectMaxIdTable WHERE someValue = 1;
            `)).results);
            console.log((await connection.rawQuery(`
                SELECT * FROM selectMaxIdTable;
            `)).results);
            console.log((await connection.rawQuery(`
                SELECT * FROM selectMaxIdTable WHERE someValue = 1;
            `)).results);
            await connection.rawQuery("COMMIT;");
        });
    });

    t.end();
});
